import javax.swing.JDialog;
import javax.swing.JFrame;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.Container;
import javax.swing.JLabel;
import javax.swing.JButton;
import javax.swing.JTextField;
import javax.swing.JScrollPane;
import java.lang.reflect.Array;
import javax.swing.JTable;
import javax.swing.table.AbstractTableModel;
import javax.swing.table.TableModel;
import java.awt.BorderLayout;
import java.awt.Dimension;
/**
 * Die Klasse AusgabeHaeufigkeiten dient der Ausgabe der berechneten Hufigkeiten.
 * 
 * @author (claus albowski) 
 * @version (03'06)
 */
public class AusgabeHaeufigkeiten
extends JDialog
{
    private JTable tabelle;
    private JLabel labelKappa, labelLaenge;
    private JButton endeButton;
    private JTextField kappaTextField;
    private JScrollPane scroll;
    private AbstractTableModel dasModell;
    private int[] haeufigkeiten;

    /**
     * Konstruktor fr Objekte der Klasse AusgabeHaeufigkeiten
     * mit kappa und laenge.
     */
    public AusgabeHaeufigkeiten(JFrame owner, 
          String title, boolean modal,
          int[] haeufigkeiten, double kappa, double laenge)
    {
        super(owner, title, modal);
        this.haeufigkeiten=haeufigkeiten;
        setSize(320, 320);
        setLocation(120, 120);
        Container contentPane = getContentPane();
        contentPane.setLayout(null);
        // Anfang Komponenten
        
        // Tabelle
        dasModell = new ModellKlasse();
        setzeTabellenDaten();
        tabelle = new JTable(dasModell);
        scroll = new JScrollPane(tabelle);
        scroll.setBounds(10, 10, 300, 200);
        contentPane.add(scroll);
        
        labelKappa = new JLabel("kappa");
        labelKappa.setBounds(10, 210, 100, 20);
        contentPane.add(labelKappa);
        
        kappaTextField = new JTextField(""+kappa);
        kappaTextField.setBounds(110, 210, 200, 20);
        contentPane.add(kappaTextField);
        
        labelLaenge = new JLabel("key-Lnge");
        labelLaenge.setBounds(10, 240, 100, 20);
        contentPane.add(labelLaenge);
        
        kappaTextField = new JTextField(""+laenge);
        kappaTextField.setBounds(110, 240, 200, 20);
        contentPane.add(kappaTextField);

        endeButton = new JButton ("ENDE");
        endeButton.setBounds(60, 270, 200, 20);
        contentPane.add(endeButton);
        
        setVisible(true);
        
        endeButton.addActionListener(new ActionListener() { // reagiert auf MAUSCLICK ENDE
            public void actionPerformed(ActionEvent e) { dispose(); }
        });

        addWindowListener(new WindowAdapter() { // reagiert auf Fenster schliessen
            public void windowClosing(WindowEvent e){ dispose(); }
        });
    }
    
    /**
     * Konstruktor fr Objekte der Klasse AusgabeHaeufigkeiten
     * mit Angabe der Position im schlssel.
     */
    public AusgabeHaeufigkeiten(JFrame owner, 
          String title, boolean modal,
          int[] haeufigkeiten, int position)
    {
        super(owner, title, modal);
        this.haeufigkeiten=haeufigkeiten;
        setSize(320, 320);
        setLocation(120, 120);
        Container contentPane = getContentPane();
        contentPane.setLayout(null);
        // Anfang Komponenten
        
        // Tabelle
        dasModell = new ModellKlasse();
        setzeTabellenDaten();
        tabelle = new JTable(dasModell);
        scroll = new JScrollPane(tabelle);
        scroll.setBounds(10, 10, 300, 200);
        contentPane.add(scroll);
        
        labelKappa = new JLabel("Position");
        labelKappa.setBounds(10, 210, 100, 20);
        contentPane.add(labelKappa);
        
        kappaTextField = new JTextField(""+position);
        kappaTextField.setBounds(110, 210, 200, 20);
        contentPane.add(kappaTextField);
        
        endeButton = new JButton ("ENDE");
        endeButton.setBounds(60, 270, 200, 20);
        contentPane.add(endeButton);
        
        setVisible(true);
        
        endeButton.addActionListener(new ActionListener() { // reagiert auf MAUSCLICK ENDE
            public void actionPerformed(ActionEvent e) { dispose(); }
        });

        addWindowListener(new WindowAdapter() { // reagiert auf Fenster schliessen
            public void windowClosing(WindowEvent e){ dispose(); }
        });
    }
    
    /**
     * interne Klasse fr das Datenmodell.
     */
    private class ModellKlasse extends AbstractTableModel {
        private String[] spaltenBeschriftungen = { "Buchstabe", "Hufigkeit" };
        private Object[][] daten = new String[26][2];
        
        public int getRowCount() { return daten.length; }
        public int getColumnCount() { return spaltenBeschriftungen.length; }
        public boolean isCellEditable(int row, int col) { return false; }
        public Object getValueAt(int row, int col) { return daten[row][col]; }
        public void setValueAt(Object value, int row, int col) {
            daten[row][col] = value;
            fireTableCellUpdated(row, col);
        }
    }
    
    /**
     * Methode zum Setzen der Tabellendaten
     */
    private void setzeTabellenDaten() {
        for (int i=0; i<26; i++) {
            dasModell.setValueAt(((char) (i+65))+"\r\n",i,0);
            dasModell.setValueAt(haeufigkeiten[i]+"\r\n",i,1);
        }
    }
    

}
