import java.io.PrintWriter;
import java.io.BufferedWriter;
import java.io.FileWriter;
import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.util.ArrayList;

/**
 * Die Klasse Text dient der Ein- und Ausgabe der Textdateien
 * zum Caesarprojekt.
 * @author (claus albowski) 
 * @version (Mrz '06)
 */
public class Text implements TextInterface
{
    // Instanzvariable
    private ArrayList<String> text;
    private String nameDatei;

    /**
     * Standard - Konstruktor fr Objekte der Klasse Text
     */
    public Text(){
        text = new ArrayList();
        nameDatei = "Muster-Datei.txt";
    }
    
    /**
     * gibt den gesamten Text mit \n\r dazwischen in einem String zurck.
     */
    public String gibText(){
        StringBuffer temp=new StringBuffer();
        for (int i=0; i<text.size();i++) {
            if (i<text.size()-1) temp.append((String)text.get(i)+"\n\r");
            else temp.append(text.get(i));
        }
        return temp.toString();
    }   
    
    /**
     * setzt den gesamten Text neu.
     */
    public void neuerText(String neu){
        text=new ArrayList();
        text.add(neu);
    }
    
    /**
     * setzt den gesamten Text neu.
     * Es muss ein Textarray bergeben werden!
     */
    public void neuerText(String[] neu){
        text=new ArrayList();
        for (int i=0;i<neu.length;i++) text.add(neu[i]);
    }
    
    /**
     * verlngert den Text um einen String.
     */
    public void textAnhaengen(String neu){
        text.add(neu);
    }
    
    /**
     * setzt den Dateinamen (Ein- und Ausgabe gleich).
     */
    public void waehleDateiNamen(String name){
        nameDatei=name;
    }
    
    /**
     * schreibt den vorhandenen Text wird in die Datei.
     * ACHTUNG: bestehende Dateien werden berschrieben !!!
     */
    public void dateiSchreiben(){
        try {
            PrintWriter ausgabe
            = new PrintWriter(new BufferedWriter(new FileWriter(nameDatei)));
            for (int i=0; i<text.size();i++) {
                ausgabe.write((String)text.get(i));
                if (i<text.size()-1) ausgabe.write("\n");
            }
            ausgabe.close();
        } catch (IOException e){
            System.out.println("Fehler beim Erstellen der Datei !");
        }
    }
    
    /**
     * liest den Text aus der Datei.
     * Der aktuelle Inhalt wird gelscht.
     */
    public void dateiLesen(){
        try {
            BufferedReader eingabe
            = new BufferedReader(new FileReader(nameDatei));
            String zeile;
            text.clear();
            while ((zeile = eingabe.readLine()) != null){
                text.add(zeile);
            }
            eingabe.close();
        } catch (IOException e){
            System.out.println("Fehler beim Lesen der Datei !");
        }
    }
}
