
/**
 * Beschreibung des Interface VigenereInterface ein.
 * Vor einer bersetzung (verschlssele oder entschlssele) mssen 
 * ---entweder Schlssel und Originaltext eingegeben worden sein
 * ---oder Schlssel und Codetext eingegeben worden sein
 * 
 * @author (claus albowski) 
 * @version (April'06)
 */

public interface VigenereInterface
{
    // gibt jeweils den bearbeiteten Text aus.
    public String zeigeText();
    
    // setzt den Originaltext
    public void setzeOriginalText(String text);

    // setzt den Codetext und berechnet die Analysewerte neu.
    public void setzeCodetext(String text);

    // setzt den Schluessel
    public void setzeSchluessel(String schluessel);

    // verschluesselt den eingegebenen Text und berechnet die Analysewerte neu.
    public void verschluessele();

    // entschluesselt den eingegebenen Text
    public void entschluessele();    

    // prft, ob ein Zeichen Grobuchstabe ist.
    public boolean istGrossBuchstabe(Character c);    
    
    // gibt zum aktuellen Codetext die Hufigkeit der Buchstaben des Codes in einem Array zurck.
    public int[] gibHaeufigkeiten();

    // gibt zum aktuellen Codetext die Hufigkeit der Buchstaben des Codes
    // an der i-ten Schlsselposition an der index-ten Schlsselposition bei laenge Schlssellnge in einem Array zurck.
    public int[] gibHaeufigkeiten(int index, int laenge);

    // gibt zum aktuellen Codetext kappa zurck.
    public double gibKappa();
    
    // gibt zum aktuellen Codetext die vermutliche Schlssellnge zurck.
    public double gibLaenge();
}
